   //**********************************************************
//*   CInfo_v2_Alert.mq4                                            *
//*   Displays the time left until the next candle close   *
//*   and the spread in absolute and relative Terms        *
//*   Written by: Totoro @ forexfactory.com                *
//*   Alert added by Hullsy - guntraderz@hotmail.com       *
//**********************************************************

#property indicator_chart_window

extern int Window=0  ;    // -------------------------------------------------code for subwindow number

extern string  Part1="---- Display Settings ----";
extern bool    ShowSpread              = true;
extern bool    ShowRelative            = true;
extern string  SpreadAbsolute          = "";
extern string  SpreadRelative          = "";
extern string  Separator               = "";
extern color   Info_Label_Color        = clrBlack;
extern string  DisplayCorner           = "bottomright";
extern int     Info_font_size          = 10;
extern int     Info_X_offset           = 0;                    //horizontal (left - right) position measured from right
extern int     Info_Y_offset           = 2;                   //vertical (up - down) position measured from bottom
extern string  Info_font_type          = "Tahoma";

extern string  Part2="---- Alert Settings ----";
extern int     AlertMinsB4CandleClose  = 1;
extern bool    Use_Alert               = false;
//extern string  AlertSound              = "stops.wav";

datetime LastAlertTime;
string shortname;
   
int init()

{

   shortname="Candle Info";
   IndicatorShortName(shortname);
//   Comment("New Candle Alert");
   LastAlertTime = TimeCurrent();   
   return(0);
}
int deinit()
{
   //Comment("");
   //ObjectsDeleteAll();
   ObjectDelete(shortname + "Display");  // removed ObjectsDeleteAll() 
   return(0);
}

int start()
{
  if ((Use_Alert == true) && (LastAlertTime < Time[0]))
   {
      Alert("New Candle on ",Symbol());
      LastAlertTime = Time[0];
   }	
	
	int ttc, d, h, m, s, rest;
	string spread, sp, rel;
   string textmsg;
   ttc = Time[0] + Period()*60 - TimeCurrent();
   
   rest=ttc%86400;
   d=(ttc-rest)/86400;
   ttc=rest;
   rest=ttc%3600;
   h=(ttc-rest)/3600;
   ttc=rest;
   rest=ttc%60;
   m=(ttc-rest)/60;
   s=rest;
   
   if(ShowSpread)
   {
      if(MarketInfo("", MODE_DIGITS)==5) { sp = DoubleToStr(0.1*MarketInfo(Symbol(), MODE_SPREAD), 0); }
      else { sp = DoubleToStr(MarketInfo(Symbol(), MODE_SPREAD), 0); }
      rel = DoubleToStr(1000*(MarketInfo(Symbol(), MODE_ASK)-MarketInfo(Symbol(), MODE_BID))/MarketInfo(Symbol(), MODE_BID), 2);
      if(ShowRelative) { spread = StringConcatenate(" " + Separator + " ", sp + SpreadAbsolute + " ( " + rel + "  " + SpreadRelative + ")" ); }
      else             { spread = StringConcatenate(" " + Separator + " ", sp + SpreadAbsolute); }

   }

/*
   if(d>0)      textmsg="" + d + "d " + h + "h " + m + "m " + s + "s" + spread;
   else if(h>0) textmsg="" + h + "h " + m + "m " + s + "s" + spread;
   else if(m>0) textmsg= "" + m + "m " + s + "s" + spread;
   else         textmsg="" + s + "s" + spread;
*/

//   if(d>0)      textmsg="" + h + ": " + m + s + "s" + spread;
        if(h>0) textmsg="" + spread + "   " + h + "h " + m + "m " + s + "";
   else if(m>0) textmsg="" + spread + "   " + m + "m " + s + "";
   else         textmsg="" + spread + "   " + s + "";
      
   
   DrawAllObjects(textmsg);
   return(0);
}

void DrawAllObjects(string msg) 
{

ObjectCreate(shortname + "Display", OBJ_LABEL, Window, 0, 0);        // ---------------------------------- "Window" has been added as part of the code for subwindow number
ObjectSetText(shortname + "Display",msg,Info_font_size, Info_font_type, Info_Label_Color);
ObjectSet(shortname + "Display", OBJPROP_CORNER, CheckCorner());
ObjectSet(shortname + "Display", OBJPROP_XDISTANCE, 2+Info_X_offset);
ObjectSet(shortname + "Display", OBJPROP_YDISTANCE, 2+Info_Y_offset);     // ------------------ vertical distance from bottom

return;
}

int CheckCorner()
{
   if(DisplayCorner=="topleft")
   {
      return(0);
   }
   else if(DisplayCorner=="topright") 
   {
      return(1);
   }
   else if(DisplayCorner=="bottomleft")
   {
      return(2);
   }
   else if(DisplayCorner=="bottomright")
   {
      return(3);
   }
   else
   {
      return(0);
   }
}